Skip to Content

CreateEndpoint

POST
/webhooks/v1/projects/{project_id}/endpoints

CreateEndpoint registers a new HTTPS endpoint and returns its signing secret exactly once. Store it; only a rotation returns a secret again.

Path Parameters

project_id*project_id
Length1 <= length

Request Body

required
application/json
{
  "url": "string",
  "event_types": [
    "image.ready"
  ]
}
url?string
event_types?array<string>

Response Body

200application/json

Success

type: unknown

{
  "$ref": "#/components/schemas/webhooks.v1.CreateEndpointResponse",
  "$ref-value": {
    "type": "object",
    "properties": {
      "endpoint": {
        "title": "endpoint",
        "$ref": "#/components/schemas/webhooks.v1.WebhookEndpoint",
        "$ref-value": {
          "type": "object",
          "properties": {
            "id": {
              "type": "string",
              "examples": [
                "whe9aB8cD1x"
              ],
              "title": "id"
            },
            "project_id": {
              "type": "string",
              "examples": [
                "Bq4y3QB38S"
              ],
              "title": "project_id"
            },
            "url": {
              "type": "string",
              "examples": [
                "https://example.com/hooks/rixl"
              ],
              "title": "url"
            },
            "event_types": {
              "type": "array",
              "examples": [
                [
                  "image.ready",
                  "image.failed"
                ]
              ],
              "items": {
                "type": "string",
                "examples": [
                  [
                    "image.ready",
                    "image.failed"
                  ]
                ]
              },
              "title": "event_types"
            },
            "enabled": {
              "type": "boolean",
              "examples": [
                "true"
              ],
              "title": "enabled"
            },
            "disabled_reason": {
              "type": "string",
              "examples": [
                "gone"
              ],
              "title": "disabled_reason"
            },
            "created_at": {
              "examples": [
                "2026-10-19T12:00:00Z"
              ],
              "title": "created_at",
              "$ref": "#/components/schemas/google.protobuf.Timestamp",
              "$ref-value": {
                "type": "string",
                "examples": [
                  "2023-01-15T01:30:15.01Z",
                  "2024-12-25T12:00:00Z"
                ],
                "format": "date-time",
                "description": "A point in time in RFC 3339 format, with up to nanosecond precision. Output uses UTC (`Z`); input may use an offset from UTC."
              }
            },
            "updated_at": {
              "examples": [
                "2026-10-19T12:00:00Z"
              ],
              "title": "updated_at",
              "$ref": "#/components/schemas/google.protobuf.Timestamp",
              "$ref-value": {
                "type": "string",
                "examples": [
                  "2023-01-15T01:30:15.01Z",
                  "2024-12-25T12:00:00Z"
                ],
                "format": "date-time",
                "description": "A point in time in RFC 3339 format, with up to nanosecond precision. Output uses UTC (`Z`); input may use an offset from UTC."
              }
            }
          },
          "title": "WebhookEndpoint",
          "additionalProperties": false,
          "description": "WebhookEndpoint is a delivery target. Secrets are never returned; they are\n only shown once on create and rotate."
        }
      },
      "secret": {
        "type": "string",
        "examples": [
          "whsec_6PJkX9sR3uVbNwYqTzLeHdCgAfMjKoQx"
        ],
        "title": "secret",
        "description": "Signing secret in whsec_<base64> form. Returned only here."
      }
    },
    "title": "CreateEndpointResponse",
    "additionalProperties": false
  }
}
defaultapplication/json

An unexpected error response.

type: unknown

{
  "$ref": "#/components/schemas/google.rpc.Status",
  "$ref-value": {
    "type": "object",
    "properties": {
      "code": {
        "type": "integer",
        "format": "int32",
        "description": "The status code, which should be an enum value of google.rpc.Code."
      },
      "message": {
        "type": "string",
        "description": "A developer-facing error message."
      },
      "details": {
        "type": "array",
        "items": {
          "$ref": "#/components/schemas/google.protobuf.Any",
          "$ref-value": {
            "type": "object",
            "properties": {
              "@type": {
                "type": "string",
                "description": "A URL/resource name that uniquely identifies the type of the serialized message."
              }
            },
            "additionalProperties": true,
            "description": "Contains an arbitrary serialized message along with a @type that describes the type of the serialized message."
          }
        },
        "description": "A list of messages that carry the error details."
      }
    },
    "description": "The Status type defines a logical error model suitable for gRPC and REST APIs."
  }
}
curl -X POST 'https://api.rixl.com/webhooks/v1/projects/string/endpoints' \
  -H 'Content-Type: application/json' \
  -d '{}'

Success

application/json

{
  "$ref": "#/components/schemas/webhooks.v1.CreateEndpointResponse",
  "$ref-value": {
    "type": "object",
    "properties": {
      "endpoint": {
        "title": "endpoint",
        "$ref": "#/components/schemas/webhooks.v1.WebhookEndpoint",
        "$ref-value": {
          "type": "object",
          "properties": {
            "id": {
              "type": "string",
              "examples": [
                "whe9aB8cD1x"
              ],
              "title": "id"
            },
            "project_id": {
              "type": "string",
              "examples": [
                "Bq4y3QB38S"
              ],
              "title": "project_id"
            },
            "url": {
              "type": "string",
              "examples": [
                "https://example.com/hooks/rixl"
              ],
              "title": "url"
            },
            "event_types": {
              "type": "array",
              "examples": [
                [
                  "image.ready",
                  "image.failed"
                ]
              ],
              "items": {
                "type": "string",
                "examples": [
                  [
                    "image.ready",
                    "image.failed"
                  ]
                ]
              },
              "title": "event_types"
            },
            "enabled": {
              "type": "boolean",
              "examples": [
                "true"
              ],
              "title": "enabled"
            },
            "disabled_reason": {
              "type": "string",
              "examples": [
                "gone"
              ],
              "title": "disabled_reason"
            },
            "created_at": {
              "examples": [
                "2026-10-19T12:00:00Z"
              ],
              "title": "created_at",
              "$ref": "#/components/schemas/google.protobuf.Timestamp",
              "$ref-value": {
                "type": "string",
                "examples": [
                  "2023-01-15T01:30:15.01Z",
                  "2024-12-25T12:00:00Z"
                ],
                "format": "date-time",
                "description": "A point in time in RFC 3339 format, with up to nanosecond precision. Output uses UTC (`Z`); input may use an offset from UTC."
              }
            },
            "updated_at": {
              "examples": [
                "2026-10-19T12:00:00Z"
              ],
              "title": "updated_at",
              "$ref": "#/components/schemas/google.protobuf.Timestamp",
              "$ref-value": {
                "type": "string",
                "examples": [
                  "2023-01-15T01:30:15.01Z",
                  "2024-12-25T12:00:00Z"
                ],
                "format": "date-time",
                "description": "A point in time in RFC 3339 format, with up to nanosecond precision. Output uses UTC (`Z`); input may use an offset from UTC."
              }
            }
          },
          "title": "WebhookEndpoint",
          "additionalProperties": false,
          "description": "WebhookEndpoint is a delivery target. Secrets are never returned; they are\n only shown once on create and rotate."
        }
      },
      "secret": {
        "type": "string",
        "examples": [
          "whsec_6PJkX9sR3uVbNwYqTzLeHdCgAfMjKoQx"
        ],
        "title": "secret",
        "description": "Signing secret in whsec_<base64> form. Returned only here."
      }
    },
    "title": "CreateEndpointResponse",
    "additionalProperties": false
  }
}